<?php

/************************************************************************/
/* File to install Php-MultiShop as Add-on of PHP-Nuke                  */
/*                                                                      */
/* WARNING:                                                             */
/* before read the instruction on Multishop_Addon/README.txt file       */
/* after run this script.                                               */
/*                                                                      */
/* Copyright (c) 2005 by Piero Trono                                    */
/* http://php-multishop.com                                             */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
/* $Id: install-addon.php,v 1.2 2005/05/29 19:45:22 tropic Exp $ */

@include("mainfile.php");

function instructions(){

?>

<center>
=========================================<br>
How To install Php-MultiShop as Addon<br>
=========================================
</center>
<p>
If you already have a PhpNuke portal and you want to install Php-MultiShop
as Add-on, follow the instructions below:

<p>
<b>1: Upgrade PHPNuke</b>
<br>First, you have to upgrade your PhpNuke:<br>
with the current version of Php-multishop (<b>0.7</b>) you can upgrate your Phpnuke to the 7.6 version 
(included the Security Patch 3.0) following the instructions in Nuke/upgrade folder.

<br><br>
Important Notes:
<br>a) with the current version of Php-multishop (0.7),
 PHP-Nuke version 7.7 (or successive) doesn't works yet !!!
<br>b) If you have PHPNuke 7.6 without the Security Patch 3.0, you must upgrade you portal to this Patch.
<p>
<b>2: Edit 'config.php' file</b>
<br>
Copy your configuration data from the 'config.php' file of your existing Phpnuke
to the config.php file included in php-multishop package: (Php-MultiShop/Nuke/html/config.php)

<p>
<b>3: Upload files</b>
<br>
For security reasons, make a backup of your filesystem,
then overwrite the content of 'Php-MultiShop/Nuke/html/' folder on your server, for example:
<br><br>
&nbsp;&nbsp;&nbsp;&nbsp;
cp -R Php-MultiShop/Nuke/html/*    /var/www/your-phpnuke-folder/

<p>
<b>4: Backup and Import DataBase</b>
<br>Make a backup of your DB and import the new data through the file:
<br><br>&nbsp;&nbsp;&nbsp;&nbsp;
	Php-MultiShop/Multishop_as_Addon/multishop_addon.sql
<br><br>
For example, if your DB is named 'nuke' (*):
<br><br>
&nbsp;&nbsp;&nbsp;&nbsp;
mysqldump nuke > backup.sql
<br>&nbsp;&nbsp;&nbsp;&nbsp;
mysql nuke < multishop_addon.sql
<br><br>
(*) with the required permissions: user and password

<p>
<form name="addon1" action="install-addon.php" method="post">
<b>4: Run this script</b> clicking on <input type="submit" name="sub" value="Start"> and after the regular process of installation,
delete this file from your server.
</form>
<?
}

function step1(){
	global $dbname, $db;
	$result = $db->sql_query("show tables");
	$num = 0;
	while ($row = $db->sql_fetchrow($res)){
		if ($row['0'] == "address_book" || $row['0'] == "customers" || $row['0'] == "nuke_users") $num ++;
	}
	if ($num == 3){
		echo '<form name="step2" action="install-addon.php" method="post">';
		echo '<b>... OK</b>, go to ';
		echo '&nbsp;<input type="submit" name="sub" value="Step 2">';
		echo '</form>';
	} else {
		echo '<br>... <font color="red"><b>Error</b></font>: check your DB (the required tables for this process are address_book, customers, nuke_users)!';
	}
	
}

function step2(){
	global $dbname, $prefix, $db, $op;
	echo "<br>... checking <i>username</i> and <i>email</i> of existing users:";
	$num = $db->sql_fetchrow($db->sql_query("SELECT count(*) FROM ".$prefix."_users WHERE username!='Anonymous'"));
	echo "<br><b>$num[0]</b> users found \n\n";
	echo '(<a href="install-addon.php?sub=Step%202&amp;op=detail">show details</a>)';
	if($op == "detail"){
		$result = $db->sql_query("SELECT user_id, username, user_email FROM ".$prefix."_users WHERE username!='Anonymous'");
		if ($db->sql_numrows($result) > 0 ){
			echo "<table border=1><tr><th>&nbsp;user_id&nbsp;</th><th>&nbsp;username&nbsp;</th><th>&nbsp;email&nbsp;</th></tr>\n";
			while ($row = $db->sql_fetchrow($result)) {
				echo "<tr><td>&nbsp;". $row['user_id']. "&nbsp;</td><td>&nbsp;" . $row['username'] . "&nbsp;</td><td>&nbsp;". $row['user_email'] . "</td></tr>\n";//$admins = explode(",", $row[admins]);
			}
			echo "</table>";
		}
	}
	$result = $db->sql_query("SELECT user_id, username, user_email FROM ".$prefix."_users WHERE (username='' or username='NULL' or user_email='NULL' or user_email='') and username!='Anonymous'");
	if ($db->sql_numrows($result) > 0 ){
		echo '<br>... <font color="red"><b>Error !</b></font> Check your DB: for the following users are missing username and/or email:<br>' . "\n";
		echo "<table border=1><tr><th>&nbsp;user_id&nbsp;</th><th>&nbsp;username&nbsp;</th><th>&nbsp;email&nbsp;</th></tr>\n";
		while ($row = $db->sql_fetchrow($result)) {
			echo "<tr><td>&nbsp;". $row['user_id']. "&nbsp;</td><td>&nbsp;" . $row['username'] . "&nbsp;</td><td>&nbsp;". $row['user_email'] . "</td></tr>\n";//$admins = explode(",", $row[admins]);
		}
		echo "</table>";
	} else {
		echo '<form name="step3" action="install-addon.php" method="post">';
		echo '<b>... OK</b>, go to ';
		echo '&nbsp;<input type="submit" name="sub" value="Finish">';
		echo '</form>';
	}
}

function step3(){
	global $dbname, $prefix, $db;
	$res1 = $db->sql_query("DELETE FROM address_book");
	$res2 = $db->sql_query("DELETE FROM customers WHERE customers_id > 1");
	$result = $db->sql_query("SELECT user_id, username, user_email, user_password FROM ".$prefix."_users WHERE username!='' and user_email!='' and username!='Anonymous' ORDER BY user_id");
	if ($db->sql_numrows($result) > 0 ){
		echo '<br>... importing the existing nuke-users as customers :<br>' . "\n";
		$num = 0 ;
		while ($row = $db->sql_fetchrow($result)) {
			//echo "<br>&nbsp;". $row['user_id']. "&nbsp;" . $row['username'] . "&nbsp;". $row['user_password'] . "\n";
#== // insert customers
		    $db->sql_query("INSERT INTO address_book (customers_id, entry_firstname) VALUES ('$row[user_id]','$row[username]') ");
		    $address_id = $db->sql_nextid();
		    $db->sql_query("INSERT INTO customers (customers_id, customers_firstname, customers_email_address, customers_password, customers_default_address_id) VALUES ('" . $row['user_id'] . "', '" . $row['username'] . "', '" . $row['user_email'] . "', '" . $row['user_password'] . "', '" . $address_id . "')");
			$num ++;
#== //
		}
		echo '<br>&nbsp;&nbsp;<b>OK</b> : imported <b>' . $num . '</b> customers.'
			.'<br><br>&nbsp;&nbsp;&nbsp;&nbsp;<b>Php-MultiShop</b> is now installed on your PHPNuke system,<br>'
		    .'&nbsp;&nbsp;&nbsp;&nbsp;you should now <font color=red><b>delete</b></font> this file from your server.<br><br>';
	} else {
		echo '<br>... <font color="red"><b>Error</b></font>: check your DB (users not found)!';
	}	
}

#####################  Start script  ###########################

echo '<br><center>File to install <b>Php-MultiShop</b> as Addon of PHPNuke</center><br>'
	.'<b>WARNING</b>:<br>&nbsp;&nbsp;before read the <a href="install-addon.php?show=doc"><b>instruction</b></a>' // on Multishop_Addon/README.txt file,<br>&nbsp;&nbsp;after run this script following in order the steps:"
	.'<br>&nbsp;&nbsp;after run this script following in order the steps:'
	.'<br>&nbsp;&nbsp;&nbsp;&nbsp;<i>Start</i>&nbsp;&nbsp;: check existing tables.'
	.'<br>&nbsp;&nbsp;&nbsp;&nbsp;<i>Step 2</i> : check content of <i>nuke_users</i> table.'
	.'<br>&nbsp;&nbsp;&nbsp;&nbsp;<i>Finish</i> : INSTALL (processing nuke-users as customers).<br>';

echo '<form name="addon" action="install-addon.php" method="post">';
echo '<br>&nbsp;<input type="submit" name="sub" value="Start">';
echo '</form><br>';

if ($show == "doc") instructions();


switch($sub) {
	
	case "Start":
	echo "<b>$sub</b>";
	step1();
	break;

	case "Step 2":
	echo "<b>$sub</b>";
	step2();
	break;

	case "Finish":
	echo "<b>$sub</b>";
	step3();
	break;

	default :
	break;
}

?>
